/*
Copyright (C) 2003 Bj\"orn Hoffmeister

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

package de.uni_luebeck.tcs.matlab;

public class MyHist {
    // Parameter zum darstellen der Histogramme mit Hilfe
    // der Funktion visualization.Histogram
    // dblX ist der linke Randpunkt des relevanten Intervalls
    // dblWidth ist die Breite des relevanten Intervalls
    // dblHeight ist die Hoehe des relevanten Intervalls
    double[] dblX = null;
    double dblWidth;
    double[] dblHeight = null;

    public MyHist(double[] dblData, double dblOffset, double dblWidth) {
        if ((dblData == null) || (dblOffset < 0.0) || (dblWidth <= 0.0)) return;
        int n = dblData.length;
        if (n == 0) return;
        double[] dblSorted = new double[n];
        
        for (int i=0; i < n; i++) {
            dblSorted[i] = Math.ceil((dblData[i] - dblOffset) / dblWidth);
        }        
        Sort.sort(dblSorted);
        int m = (new Double(dblSorted[n-1] - dblSorted[0])).intValue() + 1;
        this.dblX = new double[m];
        this.dblWidth = dblWidth;
        this.dblHeight = new double[m];
        double dblTemp = dblSorted[0];
        for (int i=0; i < dblX.length; i++) {
            dblX[i] = dblOffset + dblWidth * (dblTemp + i - 1);
        }
        for (int i=0; i < n; i++) {
            dblSorted[i] = dblSorted[i] - dblTemp + 1.0;
            dblHeight[(new Double(dblSorted[i])).intValue() - 1]++;
        }
         for (int i=0; i < dblHeight.length; i++) {
            this.dblHeight[i] /= (n * dblWidth);
        }
    }
    
    public double[] getX() { return dblX; }

    public double getWidth() { return dblWidth; }

    public double[] getHeight() { return dblHeight; }
    
}

