/*
Copyright (C) 2003 Bj\"orn Hoffmeister

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

package de.uni_luebeck.tcs.matlab;

/**
* vector norm ...
*   NORM(V,P) = sum(abs(V).^P)^(1/P).
*   NORM(V) = norm(V,2).
*   NORM(V,inf) = max(abs(V)).
*   NORM(V,-inf) = min(abs(V)).
*/

public class Norm {
    
    public static double norm(double[] x) {
        return norm(x, 2.0);
    }
    
    public static double norm(double[] x, double norm) {
        double y = 0.0;
        if (norm == 2.0) {
            for (int i=0; i < x.length; i++) {
                y += (x[i] * x[i]);
            }        
            y = Math.sqrt(y);
        } else if (norm == Double.POSITIVE_INFINITY) {
            for (int i=0; i < x.length; i++) {
                y = Math.max(Math.abs(y), Math.abs(x[i]));
            }
        } else if (norm == Double.NEGATIVE_INFINITY) {
            for (int i=0; i < x.length; i++) {
                y = Math.min(Math.abs(y), Math.abs(x[i]));
            }
        } else {
            for (int i=0; i < x.length; i++) {
                y += Math.pow(Math.abs(x[i]), norm);
            }        
            y = Math.pow(y, 1/norm);
        }
        return y;
    }
}

    
