/*
Copyright (C) 2003 Bj\"orn Hoffmeister

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

package de.uni_luebeck.tcs.visualization;

public class Debug {
	String str = "";
	
	public Debug() {};
	
	public Debug(String str) { this.str = "[" + str + "] "; }
	
	public void o(String str) { out(str); }
	public void o(int i) { out(i); }
	public void o(double d) { out(d); }
	public void o(int[] i) { out(i); }
	public void o(double[] d) { out(d); }
	public void o(String str, int i) { out(str, i); }
	public void o(String str, double d) { out(str, d); }
	public void o(String str, int[] i) { out(str, i); }
	public void o(String str, double[] d) { out(str, d); }
	
	public void out(String str) { 
		System.out.println(this.str + str); 
	}
	
	public void out(int i) { 
		System.out.println(this.str + i);
	}
	
	public void out(double d) {
		System.out.println(this.str + d);
	}
		
	public void out(int[] i) {
		out("int[]", i);
	}

	public void out(double[] d) {
		out("double[]", d);
	}
	
	public void out(String str, int d) {
		System.out.println(this.str + str + " = " + d);
	}

	public void out(String str, double d) {
		System.out.println(this.str + str + " = " + d);
	}

	public void out(String str, int[] i) {
		System.out.print(this.str + str + " = ");
		if (i == null) {
			System.out.println("null");
		} else if (i.length == 0) {
			System.out.println("{}");
		} else {
			System.out.print("{\n    ");	
			int k = 0;
			for (int j = 0; j < i.length; j++) {
				System.out.print(Range2Range.int2String(j, 3) + ":" + Range2Range.int2String(i[j], 7) + " ");
				if (++k == 4) {
					k = 0;
					System.out.print("\n    ");
				}
			}		
			if (k != 0) System.out.println();
			System.out.println("   }");
		}		
	}

	public void out(String str, double[] d) {
		System.out.print(this.str + str + " = ");
		if (d == null) {
			System.out.println("null");
		} else if (d.length == 0) {
			System.out.println("{}");
		} else {
			System.out.print("{\n    ");	
			int j = 0;
			for (int i = 0; i < d.length; i++) {			
				System.out.print(Range2Range.int2String(i, 3) + ":" + Range2Range.double2String(d[i], 4, 4, true) + " ");
				if (++j == 4) {
					j = 0;
					System.out.print("\n    ");
				}
			}
			if (j != 0) System.out.println();
			System.out.println("   }");
		}
	}
	
}
