/*
Copyright (C) 2003 Bj\"orn Hoffmeister

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

package de.uni_luebeck.tcs.visualization;

public class Range2Range {
	double d2iA;
	double d2iB;
	double i2dA;
	double i2dB;
	
	public Range2Range(int a0i, int a1i, double b0, double b1) {
		double a0 = (new Integer(a0i)).doubleValue();
		double a1 = (new Integer(a1i)).doubleValue();
		i2dA = (b0 - b1) / (a0 - a1);
		i2dB = b0;
		d2iA = (a0 - a1) / (b0 - b1);
		d2iB = a0;
	}
	
	public double toDoubleRange(int x) {
		return ((new Integer(x)).doubleValue() - d2iB) * i2dA + i2dB;
	}
	
	public int toIntRange(double x) {
		return (new Double(Math.round((x - i2dB) * d2iA + d2iB))).intValue();
	}

// statische Methoden zur Umrechnung
	// von int nach int
	public static int transform(int x, int a0, int a1, int b0, int b1) {
		return (new Double(Math.round(transform(
			x,
			(new Integer(a0)).doubleValue(),
			(new Integer(a1)).doubleValue(),
			(new Integer(b0)).doubleValue(),
			(new Integer(b1)).doubleValue()
		)))).intValue();
	}	

	// von double nach double
	public static double transform(double x, double a0, double a1, double b0, double b1) {
		double f = (b1 - b0) / (a1 - a0);
		double y = (x - a0) * f + b0;
		return y;
	}

	// von int nach double
	public static double transform(int x, int a0, int a1, double b0, double b1) throws NumberFormatException {
		return transform(
			(new Integer(x)).doubleValue(),
			(new Integer(a0)).doubleValue(),
			(new Integer(a1)).doubleValue(),
			b0,
			b1
		);
	}
 
 	//von double nach int
 	public static int transform(double x, double a0, double a1, int b0, int b1) throws NumberFormatException {
 		return (new Double(Math.round(transform(
			x,
			a0,
			a1,
			(new Integer(b0)).doubleValue(),
			(new Integer(b1)).doubleValue()
		)))).intValue();
	}

/*
	// Darstellung von double-Werten
	// maxDigits = maximale Laenge des Strings, -1 = beliebig
	// maxDigitsLZ = maximale Anzahl des Nachkommastellen, -1 = beliebig
	public static String double2String(double x, int maxDigits, int maxDigitsLZ) {
		String strX = Double.toString(x);
		if (maxDigits == -1) maxDigits = strX.length();
		if (maxDigitsLZ == -1) maxDigits = strX.length();        	
		String strE = (strX.indexOf('e') != -1)?strX.substring(strX.indexOf('e')):"";
		String strD = strX.substring(0, strX.length() - strE.length());
		int intC = strD.indexOf('.');
		String strGZ = (intC != -1)?strD.substring(0, intC):strD;
		String strLZ = (intC != -1)?strD.substring(intC + 1, strD.length()):"";
		if (strGZ.length() + strE.length() >= maxDigits) return (strGZ + strE);
		int intDigitsLZ = Math.min(maxDigits - (strGZ.length() + strE.length()), maxDigitsLZ);
		intDigitsLZ = Math.min(intDigitsLZ, strLZ.length());
		return (strGZ + ((maxDigitsLZ == 0)?"":("." + strLZ.substring(0, intDigitsLZ))) + strE);
	}
*/
	
	// Darstellung von double-Werten
	public static String double2String(double x, int inDigitsGZ, int intDigitsLZ) {
		return double2String(x, inDigitsGZ, intDigitsLZ, false);
	}

	public static String double2String(double x, int inDigitsGZ, int intDigitsLZ, boolean blnFill) {
		return double2String(
			x,
			inDigitsGZ,
			intDigitsLZ,
			3,
			'.',
			'e',
			blnFill,
			blnFill,
			blnFill,
			' ',
			'0',
			' '
		);
	}	
	
	public static String double2String(
			double x, 
			int intDigitsGZ, 
			int intDigitsLZ, 
			int intDigitsE, 
			char chrSeperator,
			char chrE,
			boolean blnFillGZ,
			boolean blnFillLZ,
			boolean blnFillE,
			char chrFillGZ,
			char chrFillLZ,
			char chrFillE
	) {		
		String strX = Double.toString(x);		
		boolean isE = true;
		boolean isLZ = true;
//		if ((intDigitsGZ == -1) && (intDigitsLZ == -1)) return strX;

		String strE = (strX.indexOf('E') != -1)?strX.substring(strX.indexOf('E') + 1):"";
		String strD = strX.substring(0, strX.length() - strE.length());
		int intC = strD.indexOf('.');		

		if (strE.length() == 0) isE = false;
		if ((strE.length() < intDigitsE) && blnFillE) {
			StringBuffer sbfFill = new StringBuffer(intDigitsE - strE.length());
			for (int i = 0; i < intDigitsE - strE.length(); i++) sbfFill.append(chrFillE);
			strE = strE + sbfFill.toString();
		}

		String strGZ = (intC != -1)?strD.substring(0, intC):strD;
		if ((strGZ.length() < intDigitsGZ) && blnFillGZ) {
			StringBuffer sbfFill = new StringBuffer(intDigitsGZ - strGZ.length());
			for (int i = 0; i < intDigitsGZ - strGZ.length(); i++) sbfFill.append(chrFillGZ);
			strGZ = sbfFill.toString() + strGZ;
		}		

		String strLZ = (intC != -1)?strD.substring(intC + 1, strD.length()):"";
		if ((intDigitsLZ == 0) || ((strLZ.length() == 0) && ((blnFillLZ == false) || (chrFillLZ == ' ')))) isLZ = false;
		if ((strLZ.length() > intDigitsLZ) && (intDigitsLZ >= 0)) {
			strLZ = strLZ.substring(0, intDigitsLZ);
		} else if ((strLZ.length() < intDigitsLZ) && blnFillLZ) {
			StringBuffer sbfFill = new StringBuffer(intDigitsLZ - strLZ.length());
			for (int i = 0; i < intDigitsLZ - strLZ.length(); i++) sbfFill.append(chrFillLZ);
			strLZ = strLZ + sbfFill.toString();
		}		
		
		String strESeperator;
		if (isE) {
			strESeperator = new String(new char[]{chrE});
		} else {
			if (blnFillE) {
				strESeperator = " ";
			} else {
				strESeperator = "";
			}			
		}
		String strSeperator;
		if (isLZ) {
			strSeperator = new String(new char[]{chrSeperator});
		} else {
			strSeperator = "";
			if (blnFillLZ) strE = new String(strE + " ");
		}
		
		return (strGZ + strSeperator + strLZ + strESeperator + strE);
	}
	
	// Darstellung von int-Werten
	public static String int2String(int x, int intDigits) {
		return int2String(x, intDigits, ' ');
	}	
	
	public static String int2String(
		int x,
		int intDigits,
		char chrFill
	) {
		String strX = Integer.toString(x);
		if (strX.length() < intDigits) {
			StringBuffer sbfFill = new StringBuffer(intDigits - strX.length());
			for (int i = 0; i < intDigits - strX.length(); i++) sbfFill.append(chrFill);
			strX = sbfFill.toString() + strX;
		}
		
		return strX;
	}
	
	// Gibt die den double-Wert von str zurueck
	// Kann dieser nicht ermittelt werden, wird def zurueckgegeben
	public static double string2double(String str, double def) {
		double x = def;
		try {
			x = (Double.valueOf(str)).doubleValue();
        } catch(NumberFormatException ignore) {}
        return x;
    }            

	// Gibt die den double-Wert von str zurueck
	// Kann dieser nicht ermittelt werden oder ist def nicht in [a0, a1] wird def zurueckgegeben
	public static double string2double(String str, double def, double a0, double a1) {
		double x = string2double(str, def);
		if ((x < a0) || (x > a1)) x = def;
		return x;
	}
	
}
