/*
Copyright (C) 2003 Bj\"orn Hoffmeister

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

package de.uni_luebeck.tcs.visualization;

// Stellt ein Liniendiagramm da. 
// Eine Linie beginnt bei 0 und y durch einen fetten Punkt markiert wird
// Repraesentiert wird sie durch zwei Arrays mit den x- und y-Werten der einzelnen
// Linien.
public class Stem extends AbstractLine {
	private static final int DIAMETER = 9;
	
	protected double[] dblX, dblY;
	
	public Stem(double[] dblX, double[] dblY) throws Exception {
		if (dblX == null)
			throw new Exception("Arrays must not be null");
		if (dblX.length == 0)
			throw new Exception("Arrays must have at least one element");
		if (dblX.length != dblY.length)
			throw new Exception("Arrays must have the same length");
		this.dblX = dblX;
		this.dblY = dblY;
		this.dblXMax = getMax(dblX);
		this.dblXMin = getMin(dblX);
		int intHD = DIAMETER / 2;
		this.dblYMax = Math.max(0, getMax(dblY));
		this.dblYMin = Math.min(0, getMin(dblY));
	}
		
	public void drawLine(AxesGraphicsInterface agr) {
		for (int i=0; i < dblX.length; i++) {
			agr.drawLine(dblX[i], 0, dblX[i], dblY[i]);
			agr.fillCircle(dblX[i], dblY[i], DIAMETER);
		}
	}
}
