/*
Copyright (C) 2003 Bj\"orn Hoffmeister

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

package de.uni_luebeck.tcs.visualization;

/** 
* Zeichnet eine Treppe
* Dabei wird die Strecke zwischen dblX[i] und dblX[i+1] in der Hoehe dblY[i] gezeichnet
*/
public class Step extends AbstractLine {
	private double[] dblX;
	private double[] dblY;
	
	public Step(double[] dblX, double[] dblY) throws Exception {
		if (dblX == null)
			throw new Exception("Arrays must not be null");
		if (dblX.length < 2)
			throw new Exception("Arrays must have at least two elements");
		if (dblX.length != dblY.length+1)
			throw new Exception("Array dblX must have one element more than array dblY");
		this.dblX = dblX;
		this.dblY = dblY;
		this.dblXMin = getMin(dblX);
		this.dblXMax = getMax(dblX);
		this.dblYMin = getMin(dblY);
		this.dblYMax = getMax(dblY);
	}

	// Zeichnet das Objekt
	public void drawLine(AxesGraphicsInterface agr) {
		for (int i=0; i < dblY.length; i++) {
			agr.drawLine(dblX[i], dblY[i], dblX[i+1], dblY[i]);
		}
	}
}
