/*
Copyright (C) 2003 Bj\"orn Hoffmeister

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

package de.uni_luebeck.tcs.visualization;

public class Tag implements Line{
	private double x, y;
	private String str;
	private char sign;
	
	public Tag(double x, double y, String str) throws Exception {
		this(x, y, str, '.');
	}
	
	public Tag(double x, double y, String str, char sign) throws Exception {
		if (str == null)
			throw new Exception("String must not be null");
		this.x = x;
		this.y = y;
		this.str = str;
		this.sign = sign;
	}

	public double getMinX() {
		return x;
	}

	public double getMaxX() {
		return x;
	}
	
	public double getMinY() {
		return y;
	}

	public double getMaxY() {
		return y;
	}
	
	public void draw(AxesGraphicsInterface agr) {
		if (sign != '.')
			agr.drawPoint(x, y, sign);
		agr.drawString(x, y, str);
	}
	
}
